void drawData() { //<>// //<>// //<>//

  if (rotate)
    rotateX(-PI/2);

  drawPath();

  if (annotation)
    drawAnnotation();
}


void drawPath() {
  for (int i=0; i<data.size(); i++) {
    if (overview) {
      for (int j=0; j<data.get(i).spaceTime.size()-1; j++) {
        if (data.get(i).spaceTime.get(j)[1]>= time1*60 && data.get(i).spaceTime.get(j+1)[1]<= time2*60) {
          drawline(data.get(i).spaceTime.get(j), data.get(i).spaceTime.get(j+1), data.get(i).random, 1, alpha);
        }
      }
    } else if (data.get(i).age >= age1 && data.get(i).age <= age2 
      && data.get(i).gender == gender && data.get(i).child == child && data.get(i).elder == elder 
      && data.get(i).week >= week1 && data.get(i).week <= week2  
      && data.get(i).workhour >= workhour1 &&  data.get(i).workhour <= workhour2 
      && data.get(i).salary >= salary1 &&  data.get(i).salary <= salary2
      && data.get(i).state >= state1 &&  data.get(i).state <= state2)
    {
      for (int j=0; j<data.get(i).spaceTime.size()-1; j++) {
        if (data.get(i).spaceTime.get(j)[1]>= time1*60 && data.get(i).spaceTime.get(j+1)[1]<= time2*60) {
          drawline(data.get(i).spaceTime.get(j), data.get(i).spaceTime.get(j+1), data.get(i).random, 1, alpha);
          drawDot(data.get(i).spaceTime.get(j), data.get(i).spaceTime.get(j), data.get(i).random, i);
          drawDot(data.get(i).spaceTime.get(j), data.get(i).spaceTime.get(j+1), data.get(i).random, i);
          if (labelI!=-1) {
            for (int k=0; k<data.get(labelI).spaceTime.size()-1; k++) {
              if (data.get(i).spaceTime.get(k)[1]>= time1*60 && data.get(i).spaceTime.get(k+1)[1]<= time2*60) {
                drawline(data.get(labelI).spaceTime.get(k), data.get(labelI).spaceTime.get(k+1), data.get(labelI).random, 4, 200);
              }
            }
            hint(DISABLE_DEPTH_TEST);
            cam.beginHUD();
            drawLabel(labelI);
            cam.endHUD();
            hint(ENABLE_DEPTH_TEST);
          }
        }
      }
    }
  }
}

void drawline(int[] a, int[] b, float c, int weight, int trans) {
  float x1 = radius * cos(a[0]*PI/9+c);
  float z1 = radius * sin(a[0]*PI/9+c);
  float y1 = map(a[1], 0, 1440, 720*sc, -720*sc);
  float x2 = radius * cos(b[0]*PI/9+c);
  float z2 = radius * sin(b[0]*PI/9+c);
  float y2 = map(b[1], 0, 1440, 720*sc, -720*sc);

  strokeWeight(2);
  stroke(clr[a[0]-1], trans+30);
  line(x1, y1, z1, x1, y2, z1);

  strokeWeight(weight);
  beginShape(LINES);
  stroke(clr[a[0]-1], trans);
  vertex(x1, y2, z1);
  stroke(clr[b[0]-1], trans);
  vertex(x2, y2, z2);
  endShape();
}

void drawDot(int[] a, int[] b, float c, int i) {
  pushMatrix();
  translate(radius * cos(a[0]*PI/9+c), map(b[1], 0, 1440, 720*sc, -720*sc), radius * sin(a[0]*PI/9+c));
  point(0, 0, 0);
  if (label) {
    float mouseObjectDistance = sq(mouseX-screenX(0, 0, 0))+sq(mouseY-screenY(0, 0, 0)); 
    if (mouseObjectDistance < 20) { 
      labelI = i;
      //drawLabel(i);
    } else { 
      labelI =-1;
    }
  }
  popMatrix();
}


void drawLabel(int i) {
  stroke(fontColor[1]);
  textMode(MODEL);
  textSize(14);  
  text("Interviewee's basic info", mouseX+8, mouseY+0);
  textSize(12);
  text("Age: "+ data.get(i).age, mouseX+8, mouseY+16);
  if (data.get(i).gender == true)
    text("Gender: Male", mouseX+8, mouseY+30);
  else
    text("Gender: Female", mouseX+8, mouseY+30);
  if (data.get(i).workhour==-1)
    text("Weekly working hours: No Data", mouseX+8, mouseY+44);
  else
    text("Weekly working hours: "+ data.get(i).workhour, mouseX+8, mouseY+44);
  if (data.get(i).salary==-1)
    text("Weekly earning: No Data", mouseX+8, mouseY+58);
  else
    text("Weekly earning: "+ data.get(i).salary, mouseX+8, mouseY+58);
  text("Geographic location: "+ location[data.get(i).state-1], mouseX+8, mouseY+72);

  //stroke(fontColor[1]);
  //textMode(MODEL);
  //textSize(14);  
  //text("Interviewee's basic info", 20, 500);
  //textSize(12);
  //text("Age: "+ data.get(i).age, 20, 520);
  //if (data.get(i).gender == true)
  //  text("Gender: Male", 20, 534);
  //else
  //  text("Gender: Female", 20, 534);
  //if (data.get(i).workhour==-1)
  //  text("Weekly working hours: No Data", 20, 548);
  //else
  //  text("Weekly working hours: "+ data.get(i).workhour, 20, 548);
  //if (data.get(i).salary==-1)
  //  text("Weekly earning: No Data", 20, 56);
  //else
  //  text("Weekly earning: "+ data.get(i).salary, 20, 562);
  //text("Geographic location: "+ location[data.get(i).state-1], 20, 576);
}




/////////////////   basic information //////////////////
void drawInfo() {

  ///// title ////////////
  fill(fontColor[0]);
  strokeWeight(0.5);
  stroke(fontColor[0]);
  textSize(fontSize[0]);
  textAlign(LEFT, CENTER);
  text("SPACE-TIME PATH", 20, 40);
  line(20, 55, 270, 55);

  //subheading
  fill(fontColor[1]);
  textSize(fontSize[2]);
  text("American Time Use in One Day", 20, 65);
  text("Data Source: United States Department of Labor", 20, 80);
  text("Bureau of Labor Statistics", 97, 95);
  textSize(fontSize[1]);
  text("MAT 259 | JINGYI XIAO", 20, 130);
  
}

////////// draw  annotation /////////////////////////
void drawAnnotation() {

  ///draw the line 
  strokeWeight(1);
  stroke(250);
  line(1000, -720*sc, 0, radius+180, 720*sc, 0);

  /// draw the timeline
  textSize(48);
  for (int i=0; i<21; i++)
    text(4+i+":00", radius+200, (720-60*i)*sc, 0);

  for (int i=0; i<4; i++)
    text(4-i+":00", radius+200, (60*i-720)*sc, 0);

  textSize(32);
  rotateX(PI/2);
  for (int i=0; i< 18; i++) {
    if (i>4&& i<14)
      textAlign(RIGHT);
    else
      textAlign(LEFT);
    text(activity[i], (radius+20)*cos(-i*PI/9), -(radius+20)*sin(-i*PI/9), (time2-11)*60*sc);
  }
}